class Vector
  attr_reader :axis_x, :axis_y, :axis_z
  def initialize(axis_x, axis_y, axis_z)
    @axis_x = axis_x
    @axis_y = axis_y
    @axis_z = axis_z
  end

  def self.from_points(point_a, point_b)
    coordinates = point_b.map.with_index do |item, index|
      item - point_a[index]
    end
    Vector.new(*coordinates)
  end

  def to_s
    "(#{@axis_x}, #{axis_y}, #{axis_z})"
  end

  def ==(other_vector)
    @axis_x == other_vector.axis_x &&
      @axis_y == other_vector.axis_y &&
      @axis_z == other_vector.axis_z
  end

  def sum(other_vector)
    Vector.new(@axis_x + other_vector.axis_x,
               @axis_y + other_vector.axis_y,
               @axis_z + other_vector.axis_z)
  end

  def scal_mult(other)
    @axis_x * other.axis_x + @axis_y * other.axis_y +
      @axis_z * other.axis_z
  end

  def module
    Math.sqrt(@axis_x**2 + @axis_y**2 + @axis_z**2)
  end
end
