require 'test_helper'

describe MyIO do
  describe '.read_vectors' do
    it 'should return an empty list for empty file' do
      vector_list = MyIO.read_vectors('test/data/empty_file')
      _(vector_list.size).must_equal 0
    end

    it 'should read several vectors from the filled file' do
      vector_list = MyIO.read_vectors('test/data/two_vectors')
      _(vector_list.size).must_equal 2
      vector_one = Vector.new(5, 6, 6)
      vector_two = Vector.new(6, 4, 0)
      returned_vectors = []
      vector_list.module_each do |vector|
        returned_vectors << vector
      end
      _(returned_vectors).must_equal [vector_two, vector_one]
    end
  end
end
