require 'test_helper'

describe VectorList do
  describe '#size' do
    it 'should return the amount of vectors in list' do
      list = VectorList.new
      _(list.size).must_equal 0
    end
  end

  describe '#add' do
    it 'should add vectors to the list' do
      list = VectorList.new
      list.add(Vector.new(1, 6, 8))
      _(list.size).must_equal 1
    end
  end

  describe '#module_each' do
    it 'should yield all vectors' do
      list = VectorList.new
      vector_one = Vector.new(1, 2, 3)
      vector_two = Vector.new(5, 6, 8)
      list.add(vector_one).add(vector_two)
      returned_vectors = []
      list.module_each do |vector|
        returned_vectors << vector
      end
      _(returned_vectors).must_include vector_one
      _(returned_vectors).must_include vector_two
    end

    it 'should sort all vectors' do
      list = VectorList.new
      vector_one = Vector.new(1, 2, 3)
      vector_two = Vector.new(8, 9, 10)
      vector_three = Vector.new(0, 2, 1)
      list.add(vector_one).add(vector_two).add(vector_three)
      returned_vectors = []
      list.module_each do |vector|
        returned_vectors << vector
      end
      _(returned_vectors).must_equal [vector_three, vector_one, vector_two]
    end
  end
end
